unit soru;

interface
uses telemu;

type

     TMutato=^Tselem;
     TSelem=record
       ertek:Telem;
       mutato:TMutato;
       end;

     Sor=class
        eleje,vege:TMutato;
        hiba:boolean;

        procedure ures;
        function ures_e:boolean;
        function tele_e:boolean;
        function hibas_e:boolean;
        procedure sorbol(var e:Telem);
        procedure sorba(e:TElem);
        procedure kiiras(var s:string);
        procedure elso(var e:Telem);
        constructor create;
        destructor destroy;
     end;

implementation

    constructor sor.create;
        begin
        eleje:=nil;
        vege:=nil;
        hiba:=false;
        end;

    destructor sor.destroy;
    var sv,sv2:TMutato;
              begin
              sv:=eleje;
              while sv<>nil do
                    begin
                    sv2:=sv;
                    sv:=sv^.mutato;
                    dispose(sv2);
                    end;
        end;

    procedure sor.ures;
              begin
              eleje:=nil;
              vege:=nil;
              hiba:=false;
              end;

    function sor.ures_e:boolean;
             begin
             ures_e:=(eleje=nil);
             end;

    function sor.tele_e:boolean;
             begin
             tele_e:=false;
             //tele_e:=(maxavail=sizeof(TElem));
             //ez a rutin nem mukodik.
             end;

    function sor.hibas_e:boolean;
             begin
             hibas_e:=hiba;
             hiba:=false;
             end;

    procedure sor.sorbol(var e:Telem);
         var seged:Tmutato;
              begin
              if ures_e then hiba:=true else
                 begin
                 e:=eleje^.ertek;
                 seged:=eleje^.mutato;
                 dispose(eleje);
                 eleje:=seged;
                 if eleje=nil then vege:=nil;
                 end;
              end;

    procedure sor.sorba(e:TElem);
    var uj:TMutato;
              begin
              if tele_e then hiba:=true else
                 begin
                 new(uj);
                 uj^.ertek:=e;
                 uj^.mutato:=nil;
                 if eleje=nil then eleje:=uj else
                    vege^.mutato:=uj;
                 vege:=uj;
                 end;
              end;

    procedure sor.elso(var e:Telem);
             begin
             if ures_e then hiba:=true else e:=eleje^.ertek;
             end;

    procedure sor.kiiras(var s:string);
    var sv:TMutato;
              begin
              sv:=eleje;
              s:='';
              while sv<>nil do
                    begin
                    s:=s+' '+sv^.ertek.adat;
                    //write(sv^.ertek.adat,' ');
                    sv:=sv^.mutato;
                    end;
                   {write(sv^.ertek.adat);}
              end;

begin
end.